"use strict";
/*
    Alarm Center

    - Hook new events and process for alarm keys + values
    - Submit start to new hook providing SMS + Comms out
*/
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AlarmCenter = void 0;
const hook_1 = require("./hook");
__exportStar(require("./alarm"), exports);
__exportStar(require("./utils/format"), exports);
class AlarmCenter {
    constructor(register) {
        this.cleanupHooks = [];
        this.register = register;
    }
    //Only works for local command-scada currently
    hook(alarms, alarmPathways, lastValues, values, typedValues) {
        return __awaiter(this, void 0, void 0, function* () {
            //Cleanup from last hook call
            yield Promise.all(this.cleanupHooks.map((cleanup) => {
                cleanup === null || cleanup === void 0 ? void 0 : cleanup();
            }));
            //Setup new bulk hooks
            const hookInst = new hook_1.Hook(this.register, alarms, alarmPathways);
            //Run hook and store alarm post processing function
            this.cleanupHooks = yield hookInst.run(lastValues, values, typedValues);
        });
    }
}
exports.AlarmCenter = AlarmCenter;
